.dotnet_template_defaults:
  image: mcr.microsoft.com/dotnet/sdk:9.0

dotnet format:
  extends: .dotnet_template_defaults
  script:
    - dotnet format --verbosity normal --verify-no-changes

dotnet test:
  extends: .dotnet_template_defaults
  before_script:
    - dotnet tool install dotnet-reportgenerator-globaltool --tool-path tools
    # Install JunitXml.TestLogger to all test projects
    - dirname "$(grep -lR 'Include="Microsoft.NET.Test.Sdk"')" | xargs -I {} -n1 bash -c "test -d {} && cd {} && dotnet add package JunitXml.TestLogger" > /dev/null
  script:
    - >
      dotnet test
      -c Debug
      --collect:"XPlat Code Coverage"
      --test-adapter-path:.
      --logger:"junit;LogFilePath=./junit/junit-test-result.xml;MethodFormat=Class;FailureBodyFormat=Verbose"
      -p:CollectCoverage=true
    - ./tools/reportgenerator "-reports:${CI_PROJECT_DIR}/**/coverage.cobertura.xml" "-targetdir:Reports_Coverage" -reportTypes:TextSummary;
    - ./tools/reportgenerator "-reports:${CI_PROJECT_DIR}/**/coverage.cobertura.xml" "-targetdir:Reports_Coverage" -reportTypes:Html;
    - cat ./Reports_Coverage/Summary.txt
    - echo 'End Summary'
  coverage: /Line coverage[\s\S].+%/
  artifacts:
    expose_as: 'Coverage Report'
    paths:
      - Reports_Coverage/index.html
      - Reports_Coverage
    reports:
      junit:
        - ./**/*junit-test-result.xml
      coverage_report:
        coverage_format: cobertura
        path: ./**/*coverage.cobertura.xml

resharper inspect:
  extends: .dotnet_template_defaults
  before_script:
    - dotnet tool install -g JetBrains.ReSharper.GlobalTools
    - dotnet tool install -g resharper-to-codeclimate
  script:
    - /root/.dotnet/tools/jb inspectcode ./*.sln -o=./resharper.xml
    - /root/.dotnet/tools/resharper-to-codeclimate resharper.xml codeclimate.json
  rules:
    - if: $RESHARPER_ENABLE # temporary disabled by default because of broken on .net8
  artifacts:
    reports:
      codequality: codeclimate.json
